-- ========================== delete_ip_address.adb ==========================
-- 
--  Copyright 2001 by Craig Spannring
-- 
--  Def:   Delete an IP address from the local computer.
-- 
-- ===========================================================================



with Ada.Text_IO; use Ada.Text_IO;
with Ada.Command_Line;
with Ada.Exceptions;


with Iphlpapi.thin;    use Iphlpapi.Thin; 
with Iphlpapi.Helpers; use Iphlpapi.Helpers; 

procedure Delete_Ip_Address is 
   rcs_body_revision_id: constant string := "$Header: /home/cts/PersonalRepository/iphlpapi/Attic/delete_ip_address.adb,v 1.1.2.2 2001/03/24 04:32:52 cts Exp $";
   
   package Cl renames Ada.Command_Line;
   
   use type DWORD;
   
   procedure Usage is 
   begin
      Put_Line("Usage- " & Cl.Command_Name & " context ");
   end Usage;
   
   
   Rc:        Dword;
   Context:   ULONG;
begin
   if Cl.Argument_Count /= 1 then
      Usage;
      Cl.Set_Exit_Status(Cl.Failure);
      return;
   end if;
   Context := ULONG'Value(Cl.Argument(1));
      
   Rc := DeleteIPAddress(Context);
   
   if Rc /= 0 then 
      Cl.Set_Exit_Status(Cl.Failure);
      Put_Line("Error.  rc = " & DWORD'Image(Rc));
   end if;
exception
   when Exc: others => 
      Put_Line(Ada.Exceptions.Exception_Message(Exc));
      Usage;
      Cl.Set_Exit_Status(Cl.Failure);
end Delete_Ip_Address;
