-- ===================== print_ip_interface_mapping.adb ======================
-- 
--  Copyright 2001 by Craig Spannring
-- 
--  Def:   Print the interface to IP mapping for all assigned addresses 
--         on the machine.
-- 
-- ===========================================================================


with Ada.Text_IO; use Ada.Text_IO;

with Iphlpapi.Thin;    use Iphlpapi.Thin; 
with Iphlpapi.Helpers; use Iphlpapi.Helpers; 

procedure Print_Ip_Interface_Mapping is    
   rcs_body_revision_id: constant string := "$Header: /home/cts/PersonalRepository/iphlpapi/print_ip_interface_mapping.adb,v 1.1.1.1.2.2 2001/03/22 18:20:38 cts Exp $";
   use type DWORD;
   Size:      aliased Dword;
   Rc:        Dword;
   Ip_Stats:  aliased MIB_IPSTATS;
   Table:     aliased MIB_IPADDRTABLE;
begin
   Rc := GetIpStatistics(Ip_Stats'Unchecked_Access);
   Put_Line("This computer has " & DWORD'Image(Ip_Stats.dwNumAddr)
            & " IP addresses");
   
   Size := (table'Size)/8;
   Rc := GetIpAddrTable(Table'unchecked_access, 
                        Size'unchecked_access, 
                        1);
   for I in Table.Table'First..Table.Table'First+Integer(table.DwNumEntries)-1 loop
      declare 
         Row:  MIB_IPADDRROW := Table.Table(I);
      begin
         Put_Line("interface " & DWORD'Image(Row.DwIndex));
         Put_Line("   IP:        " & IP_Address_to_String(Row.dwAddr));
         Put_Line("   mask:      " & IP_Address_to_String(Row.dwMask));
      end;
   end loop;
end Print_Ip_Interface_Mapping;

   
      
